"""

"""
from flask import Flask, request, render_template, redirect, url_for
from datetime import datetime
from threading import Thread, Timer
from api_information import weather_api, news_api
import pyttsx3, sched, json, time,threading

# Create a flask object, then the
# function can be called by url path.
app = Flask(__name__)

# 储存用户输入的时间和事件 key是用户输入的时间 value是用户输入的事件
time_event = {}

# key是时间, value重复的次数
alarm_repeat = {}

# key是时间, value是event
leakage_event = {}

# key是时间, value是事件
expired_alarm = {}

# key是时间, value是event对象, 这个是给notification用的
scheduler_checker = {}

# key是时间, value是event对象, 给alarm_ring用的
alarm_ring_event_checker = {}

# news_weather_event_checker
news_weather_event_checker = {}

default_city = ""

scheduler = sched.scheduler(time.time, time.sleep)

time_format = "%Y-%m-%d %H:%M"

# 用来收集时间
alarm_ringing = datetime.strptime(
    datetime.strftime(datetime.now(), time_format), time_format)

@app.route('/')
def user_interface():

    global default_city

    default_city = request.args.get("default_city")

    print(default_city)
    print(type(default_city))

    content = news_api()

    length = len(content[1]) - 1
    # print(length)

    context = {
                "total_results" : content[0],
                "articles" : content[1],
                "length" : length
            }

    return render_template("index.html", **context)

@app.route('/weather/')
def weather():

    """
    跳转到weather的页面, 如果用户输入了城市信息返回天气的信息给用户
    :return:
    """
    if request.args.get("city_name"):
        city = request.args.get("city_name")
        weather_info = weather_api(city)
        return render_template("weather.html", **weather_info)
    else:
        return render_template("weather.html")

@app.route('/setalarm/')
def setalarm():
    """
    用来接收前端返回过来的时间 信息 和 事件 信息
    :return:
    """
    if request.args.get('alarm'):

        # print(request.args.get('alarm')) 2019-11-18T11:01

        alarm_time = request.args.get('alarm') # 接收前端发过来的时间信息

        alarm_time = conc(alarm_time) # 将用户输入的时间进行格式处理并且转换成datetime type

        alarm_event = request.args.get("event") # 接收前端发过来的事件信息

        alarm_number = request.args.get("number") # 接收前端发过来的次数的信息如果没有输入的话默认是一次

        # print(alarm_number)

        if alarm_time > datetime.now() and alarm_event != "": # 如果传过来的事件不是空的话就传事件信息给这个函数

            time_event[alarm_time] = alarm_event

        elif alarm_time > datetime.now(): # 如果时间大于现在, 但是没有输入事件的话输入一个默认的事件

            time_event[alarm_time] = "You have a event!"

        elif alarm_time < datetime.now() and alarm_event != "": # 如果时间小于现在, 事件不为空放入dictionary

            expired_alarm[alarm_time] = alarm_event

        elif alarm_time < datetime.now(): # 如果时间小于现在, 事件为空放入dictionary

            expired_alarm[alarm_time] = "You have a event!"

        if alarm_time > datetime.now() and float(int(alarm_number)) == 1: # 如果时间大于现在,  然后接收到的循环次数小于1的话

            notifications(alarm_time)

            # alarm_ring_event_checker[alarm_time] = scheduler.enter(time_gaps(alarm_time), 1, alarm_ring, (alarm_time))

            news_weather_event_checker[alarm_time] = scheduler.enter(time_gaps(alarm_time), 1, leakage_func)

            print("schduler load event")

        elif alarm_time > datetime.now() and float(int(alarm_number)) > 1:

            alarm_repeat[alarm_time] = alarm_number

            notifications_repeat(alarm_time, int(alarm_number))



            print("schduler load repeat event")

        print(time_event)
        print(scheduler.queue)

        if scheduler.empty():

            # redirect the html page to missed alarm html

            print("empty")

            return redirect(url_for('expired_pages'), code = 302)

        else:

            print("scheduler running")

            print(threading.current_thread().name)

            Thread(target=scheduler.run, name = "scheduler_starter").start()

            content = {
                "time_event": time_event # 给前端传 时间表的信息方便用户查看
            }

            return render_template("alarm_set.html", **content)


        print(schduler_checker)

    else:

        return render_template('alarm_set.html')

@app.route('/cancel_alarm/')
def cancel_alarm() -> dict:
    """
    用来取消闹钟使用function
    逻辑是从先从前端获取用户想要删除的事件信息, 然后从global 的字典中删除对应事件信息
    :return:
    """
    alarm = request.args.get("cancel_alarm") # str

    alarm = conc(alarm) # datetime.datetime

    try:

        del time_event[alarm]

        scheduler.cancel(scheduler_checker[alarm])

        del scheduler_checker[alarm]

    except KeyError:

        return redirect(url_for('setalarm'), code=302)
    # print(alarm)
    #
    # cancel(alarm) # 在scheduler_checker 中删除对应的event, 然后删除time_event中, 删除scheduler.queue中的对应的event

    content = {
        "time_event": time_event
    }

    return render_template("alarm_set.html", **content)

@app.route('/expired_pages/')
def expired_pages():

    return render_template("expired_alarm.html", expired_alarm = expired_alarm)

@app.route('/news_weather/')
def news_weather(city = "exeter") -> dict:

    weather_info = weather_api(city)

    content = news_api()

    length = len(content[1]) - 1

    print(time_event)

    context = {
            # 'event': time_event[alarm_ringing],

            'total_results': content[0],

            'articles': content[1],

            'length' : length,

            'content' : content

    }

    return render_template('news_weathher.html', **context)

def leakage_func():

    return redirect(url_for('news_weather'), code=302)

# def alarm_ring(time: datetime) -> datetime:
#
#     global alarm_ringing
#
#     alarm_ringing = time
#



def news_update():
    try:
        while True:

            n = 0
            # 60 * 60 * 2
            Timer(n + 1, user_interface).start()

            return redirect(url_for('user_interface'), code=302)
    except:

        return redirect(url_for('user_interface'), code = 302)

def conc(string: str) -> datetime:

    """
    将前端传过来的事件进行处理, 变成datetime能够处理的样子
    :param string:
    :return:
    """
    conc_time = datetime.now() # 如果不加这个会有runtime error,

    string = string.split("T")

    try:
        conc_time = datetime.strptime(string[0] + " " + string[1], time_format)
    except:
        pass

    return conc_time

def time_gaps(users_time: datetime) -> int:
    """
    计算现在的时间和传过来的时间相差多少, 如果小于0将他放入expired_list中
    如果大于0的话放入sched方法中进行执行

    :param users_time:
    :return:
    """

    datetime_now = datetime.now() # 先获取当前时间

    time_gap = users_time - datetime_now # 然后计算出时间差

    time_gap = time_gap.total_seconds() # 获得时间的 <class 'float'>

    if time_gap >= 0.0:

        print(time_gap)

    else:

        expired_alarm[users_time] = time_event[users_time]

    return time_gap

def notifications(times: datetime) -> dict:
    """
    创建scheduler对象
    times: datetime type
    :return: a dictionary type
    """
    # global event_checker

    # 将时间和对应创建的队列放入字典中方便取消
    scheduler_checker[times] = scheduler.enter(time_gaps(times),
                                               0, tts_request,
                                               (time_event[times], ))

    print(scheduler_checker)

    return scheduler_checker

def notifications_repeat(times: datetime, numbers: int) -> None:

    a_day = float(60*60*24)

    for times in range(numbers):
        scheduler_checker[times] = scheduler.enter(time_gaps(times) +
                                                   a_day * (times + 1), 0,
                                                   tts_request,
                                                   (time_event[times], ))

def tts_request(announcement="Text to speech example announcement!"):
    """
    用来将用户的输入信息转成语音输入到网页中

    :param announcement:
    :return:
    """
    try:
        engine = pyttsx3.init()

        engine.say(announcement)

        engine.runAndWait()
    except:

        pass

    return "Hello text-to-speech example"

if __name__ == '__main__':
    app.run(debug=True, host="0.0.0.0", port=1111)
